<?php

defined('_JEXEC') or die;

class JZhongFreePremiumMigration
{

    public function __construct()
    {

        $db = JFactory::getDbo();

        $db->setQuery('SHOW ENGINES');

        try{ $results = $db->loadObjectList(); }
        catch (Exception $e) {
            echo JText::sprintf('JLIB_DATABASE_ERROR_FUNCTION_FAILED', $e->getCode(), $e->getMessage()) . '<br />';
            return;
        }

        // --------- Old positions migration --------- //

        $templates_compact = array(

            'zhong-free' =>  'zhong',
            'blueblock-free' =>  'blueblock',
            'cenere-free' =>  'cenere',
            'color3-free' =>  'color3',
            'portal-free' =>  'portal',
            'simpledot-free' =>  'simpledot',
            'vimy-free' =>  'vimy',

        );

        foreach ($templates_compact as $old_value => $new_value) {

            $db->setQuery(
                $db->getQuery(true)
                    ->update('#__template_styles')
                    ->set('template = replace(template,"'.$old_value.'","'.$new_value.'")')
                    ->set('title = replace(title,"'.$old_value.'","'.$new_value.'")')
            )->execute();

            $db->setQuery(
                $db->getQuery(true)
                    ->update('#__extensions')
                    ->set('name = replace(name,"'.$old_value.'","'.$new_value.'")')
                    ->set('element = replace(element,"'.$old_value.'","'.$new_value.'")')
                    ->set('manifest_cache = replace(manifest_cache,"'.$old_value.'","'.$new_value.'")')
            )->execute();

        }

        foreach ($templates_compact as $old_value => $new_value) {
            if( file_exists( JPATH_ROOT .'/templates/'. $old_value ) ){
                if( is_writable( JPATH_ROOT.'/templates/' ) ){
                    rename(JPATH_ROOT .'/templates/'. $old_value, JPATH_ROOT .'/templates/'. $new_value);
                } else {
                    JFactory::getApplication()->enqueueMessage(
                        'Error: '.JPATH_ROOT .'/templates/'. $old_value .' is NOT writable. You must rename this folder manually from ' . JPATH_ROOT .'/templates/'. $old_value . ' to: ' . JPATH_ROOT .'/templates/'. $new_value
                    , 'error');
                }
            }
        }

    }

}

$JZhongFreePremiumMigration = new JZhongFreePremiumMigration();
